#include "StdAfx.h"
#include "SMSDropTarget.h"

SMSDropTarget::SMSDropTarget(CSMSController* pSMSController)
: m_pSMSController(pSMSController)
{
	m_clipboardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));
}

SMSDropTarget::~SMSDropTarget(void)
{
}

DROPEFFECT SMSDropTarget::OnDragEnter( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return GetDropEffect(pDataObject);
}

DROPEFFECT SMSDropTarget::OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return GetDropEffect(pDataObject);
}

BOOL SMSDropTarget::OnDrop( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point )
{
	try
	{
		if (pDataObject->IsDataAvailable(m_clipboardFormat))
		{
			CFile* pFile = pDataObject->GetFileData(m_clipboardFormat);
			if (pFile == NULL)
			{
				return TRUE;
			}

			CArchive ar(pFile, CArchive::load); 
			int nCount = -1;

			ar >> nCount;

			if(!CheckMaxUser(pWnd, nCount))
			{
				for (int i = 0; i < nCount; ++i)
				{
					CNtalkDragData dropUser;
					dropUser.Serialize(ar);
					//޴  ߺ ƴҶ. ߰
					if(m_pSMSController->AddSMSReceiver(dropUser.m_strID, dropUser.m_strName,dropUser.m_strCellphone))
					{
						if (pWnd && pWnd->GetSafeHwnd())
							pWnd->SendMessage(WM_SMSDLG_RECEIVERLIST_ADDUSER, (WPARAM)0, (LPARAM)&dropUser);
					}
					else
					{
						if (pWnd && pWnd->GetSafeHwnd())
							pWnd->SendMessage(WM_SMSDLG_RECEIVERLIST_ADDUSER_FAIL, (WPARAM)0, (LPARAM)&dropUser);
					}
				}

			}
			ar.Close();
			delete pFile;
			return TRUE;
		}
	}
	catch (CFileException* pEx)
	{
        pEx->ReportError();
        pEx->Delete();
		return FALSE;
	}

	return COleDropTarget::OnDrop(pWnd, pDataObject, dropEffect, point);
}

DROPEFFECT SMSDropTarget::GetDropEffect( COleDataObject* pDataObject )
{
	DROPEFFECT dropEffect = DROPEFFECT_NONE;

	if (pDataObject->IsDataAvailable(m_clipboardFormat))
	{
		dropEffect = DROPEFFECT_COPY;
	}

	return dropEffect;
}

bool SMSDropTarget::CheckMaxUser( CWnd* pWnd, int nCount )
{
	bool bRet=false;
	LRESULT res = m_pSMSController->IsEnableReceiverUserCount(m_pSMSController->GetCurrentReceiverCount() + nCount);
	if(res != 0L)
	{
		if (pWnd && pWnd->GetSafeHwnd())
			pWnd->SendMessage(WM_SMSDLG_RECEIVERLIST_ADDMAXUSER, (WPARAM)0, (LPARAM)res);
		bRet=true;
	}
	return bRet;
}
